// Copyright (c) 2020 Famedly GmbH
// SPDX-License-Identifier: AGPL-3.0-or-later

import 'package:matrix_file_e2ee/matrix_file_e2ee.dart';
import 'package:test/test.dart';
import 'dart:typed_data';

void main() async {
  test('encrypt and decrypt and check, small file', () async {
    final input = Uint8List(512);
    final crypt = await encryptFile(input);
    expect(crypt.data, hasLength(input.length));
    print(crypt.k + ' ' + crypt.iv + ' ' + crypt.sha256);
    final original = await decryptFile(crypt);
    expect(input, original);
  });

  test('encrypt and decrypt, large file', () async {
    final input = Uint8List(10 << 20);
    for (var i = 0; i < input.length; i++) {
      input[i] = i % 128;
    }
    final crypt = await encryptFile(input);
    expect(crypt.data, hasLength(input.length));
    print(crypt.k + ' ' + crypt.iv + ' ' + crypt.sha256);
    await decryptFile(crypt);
  });
}
